#include <stdlib.h>
#include <stdio.h>

int main()
{
    long N, K, i, p, min, minp, mind, mindp;
    long A[500000];
    int M[500000];

    scanf("%li%li", &N, &K);

    for(i=0; i<N; i++)
    {
        scanf("%li", &A[i]);
        M[i] = 1;
    }

    p = -1;
    min = A[0] + 1;
    while(K>0 && p<N/2-K-1)
    {
        for(i=p+1; i<=p+K+1; i++)
            if(A[i]<min)
            {
                min = A[i];
                minp = i;
                mind = A[i+1];
                mindp = i + 1;
            }
            else if(A[i]<mind)
                {
                    
                }
                

        for(i=p+1; i<minp; i++)
            M[i] = 0;

        K = K - (minp - p - 1);
        p = minp;
    }


    for(i=N-K; i<N; i++)
        M[i] = 0;

    for(i = 0; i<N; i++)
        if(M[i])
            printf("%li ", A[i]);


    return 0;
}